
require_relative 'book'
require_relative 'store'

class BookLoader 
  DONE_MARKER = '<END>'

  def initialize(config_file, queue)
    @config_file = config_file
    @queue = queue
  end

  def run
    @store = Store.new(@config_file)
    @store.connect()

    file = @queue.pop
    until file == DONE_MARKER do
      book = Book.new(@store)
      book.load_from_file!(file)
      @store.store_book(book)

      file = @queue.pop
    end

    @store.disconnect()
  end
end
