
class FastSet
  @@fast_csv_file = 'fast.csv'

  def initialize
    @entries = {}
    load!(@@fast_csv_file)
  end

  def add(id, descr)
    @entries[id] = descr
  end

  def has_key?(value)
    @entries.has_key?(value)
  end

  def inspect 
    data = []

    if nil != @entries 
      data.push('entries=' + @entries.inspect + '') 
    end

    return '(FastSet:' + data.join(',') + ')'
  end

  def load!(file_name)
    first = true
    @entries = {}

    if ! File.exist?(file_name)
      puts 'WARNING:  file "' + file_name + '" not found.'
      return 
    end

    first = true
    CSV.open(file_name, 'r:UTF-8') do |csv|
      csv.to_a.each do |row|
        if first
          first = false
        elsif row.length >= 2
          id = row[0]
          descr = row[1]
          @entries[id] = descr
        end
      end
    end
  end

  def save(file_name)
    CSV.open(file_name, 'w:UTF-8') do |csv|
      csv << [ 'Code', 'Description' ]
      
      @entries.keys.sort.each do |key|
        csv << [ key.to_s, @entries[key].to_s ]
      end
    end
  end

  def save_state
    save(@@fast_csv_file)
  end
end

