
require 'rspec/autorun'
require_relative '../book'

describe Book do
  it "can handle .epub and .pdf files" do
    ['epub', 'pdf'].each do |extension|
      expect(Book.can_handle?("sample.#{extension}")).to be true
    end
  end

  it "cannot handle .mobi, .html, .txt, .doc, .zip, .rtf or .rar files" do
    %w(doc html mobi rar rtf txt zip).each do |extension|
      expect(Book.can_handle?("sample.#{extension}")).to be false
    end
  end
end
